/** A more object-oriented implementation of trees: use subclasses to implement different behavior
 * of empty vs. non-empty trees. */

public interface Tree<T> {
	/** The number of nodes in the tree. */
	int size();

	/** Whether the tree contains the value. */
	boolean contains(T value);
}
